C $Header: /u/gcmpack/MITgcm/pkg/gchem/gchem_diagnostics_init.F,v 1.2 2007/07/31 23:01:58 ce107 Exp $
C $Name:  $

#include "GCHEM_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_DIAGNOSTICS_INIT(myThid )

C !DESCRIPTION:
C define diagnostics for gchem package
C experiment

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_GCHEM
#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Define diagnostics Names :

      diagName  = 'DICBIOA '
      diagTitle = 'Biological Productivity (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICCARB '
      diagTitle = 'Carbonate chg-biol prod and remin (mol eq/m3/s)'
      diagUnits = 'mol eq/m3/sec   '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICTFLX '
      diagTitle = 'Tendency of DIC due to air-sea exch (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICOFLX '
      diagTitle = 'Tendency of O2 due to air-sea exch (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICCFLX '
      diagTitle = 'Flux of CO2 - air-sea exch (mol/m2/s)'
      diagUnits = 'mol/m2/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICPCO2 '
      diagTitle = 'Partial Pressure of CO2 (atm)'
      diagUnits = 'atm             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'DICPHAV '
      diagTitle = 'pH (dimensionless)'
      diagUnits = 'dimensionless   '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'FeL1    '
      diagTitle = 'Fe-L1 complex'
      diagUnits = 'mol/m3  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'FeL2    '
      diagTitle = 'Fe-L2 complex'
      diagUnits = 'mol/m3  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      
      diagName  = 'Ligand1    '
      diagTitle = 'Ligand1 concentration'
      diagUnits = 'mol/m3  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ligand2    '
      diagTitle = 'Ligand2 concentration'
      diagUnits = 'mol/m3  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ironscav    '
      diagTitle = 'Scavenging loss rate of Fe'
      diagUnits = 'mol/m3/2'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ironsci    '
      diagTitle = 'Inorganicscavenging loss rate of Fe'
      diagUnits = 'mol/m3/2'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )
      
      diagName  = 'Ironsco    '
      diagTitle = 'Organicscavenging loss rate of Fe'
      diagUnits = 'mol/m3/2'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )
      
      diagName  = 'Ironbio    '
      diagTitle = 'Biological uptake of iron'
      diagUnits = 'mol/m3/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ironrem    '
      diagTitle = 'Remineralization rate of iron'
      diagUnits = 'mol/m3/s  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ironreb    '
      diagTitle = 'bioremineralization rate of iron'
      diagUnits = 'mol/m3/s  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'FEremin_org    '
      diagTitle = 'inorganic particulate release of iron'
      diagUnits = 'mol/m3/s  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'WFE_inorg    '
      diagTitle = 'inorganic particulate Fe flux'
      diagUnits = 'mol/m2/s  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Ironsed    '
      diagTitle = 'Sedimentary source of Fe'
      diagUnits = 'mol/m3/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )


      diagName  = 'botfeflux    '
      diagTitle = 'botfeflux'
      diagUnits = 'mol/m2/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )
      
      diagName  = 'sedf    '
      diagTitle = 'sedf'
      diagUnits = 'mol/m2/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )
      diagName  = 'Irondust   '
      diagTitle = 'Irondust '
      diagUnits = 'mol/m3/s'
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid ) 
      

      diagName  = 'Ironloss    '
      diagTitle = 'Ironloss '
      diagUnits = 'mol/m3/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )  

      diagName  = 'IronHydro   '
      diagTitle = 'Hydrothermal source of Fe '
      diagUnits = 'mol/m3/s'
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Kscstar    '
      diagTitle = 'org scav rate'
      diagUnits = 's-1  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )

      diagName  = 'Kscavin    '
      diagTitle = 'in scav rate'
      diagUnits = 's-1  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid )


      diagName  = 'Rptl_FeP    '
      diagTitle = 'Fe:P particle ratio'
      diagUnits = 'molFe/molP  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid ) 

      diagName  = 'Ratio_FeP    '
      diagTitle = 'Fe:P ratio'
      diagUnits = 'molFe/molP  '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADD2LIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, myThid ) 
       
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_GCHEM */

      RETURN
      END
